package gssim.gssimstudio.flex.app.editor;

import java.io.*;
import java.util.*;

import org.vinetoolkit.ResourceManager;
import org.vinetoolkit.ServiceContext;
import org.vinetoolkit.Session;

import org.vinetoolkit.web.spi.annotation.BlazeDsDestination;
import org.vinetoolkit.web.spi.annotation.BlazeDsMethod;
import org.vinetoolkit.web.flex.blazeds.shared.utils.VineFlexUtilClass;
import org.vinetoolkit.web.portlet.spi.annotation.PortletDisplayName;
import org.vinetoolkit.role.VineRoleManager;
import org.vinetoolkit.spi.util.ServiceLog;

import flex.messaging.FlexContext;
import org.vinetoolkit.web.spi.annotation.BlazeDsDestination;
import org.vinetoolkit.web.spi.annotation.BlazeDsMethod;
import org.apache.commons.fileupload.FileItem;
import org.apache.commons.fileupload.disk.DiskFileItem;
import org.vinetoolkit.io.*;
import org.vinetoolkit.io.sets.FileLocationSet;
import org.vinetoolkit.ServiceContext;
import org.vinetoolkit.Location;
import org.vinetoolkit.task.TaskMonitor;
import org.vinetoolkit.task.TaskOptions;
import org.vinetoolkit.task.TaskException;
import org.vinetoolkit.localhost.io.FileSystemResource;
import org.vinetoolkit.localhost.io.FileSystemManager;
import org.vinetoolkit.spi.util.ServiceLog;

import java.sql.Connection;
import java.sql.SQLException;
import java.sql.Timestamp;

import org.vinetoolkit.web.flex.blazeds.shared.uibackend.ModelInitialization;
import org.vinetoolkit.web.flex.blazeds.shared.uibackend.FileUploadAccepter;
import java.security.Principal;

import gssim.db.dao.data.Allocation;
import gssim.db.dao.data.AllocationDetails;
import gssim.db.dao.data.BlobProperty;
import gssim.db.dao.data.Configuration;
import gssim.db.dao.data.Metaexperiment;
import gssim.db.dao.data.Experiment;
import gssim.db.dao.data.ExperimentStats;
import gssim.db.dao.data.Queues;
import gssim.db.dao.data.Plugin;
import gssim.db.dao.data.PluginCompatibility;
import gssim.db.dao.data.Reservation;
import gssim.db.dao.data.ReservationDetails;
import gssim.db.dao.data.Resource;
import gssim.db.dao.data.ResourceAllTimeline;
import gssim.db.dao.data.ResourceEnTimeline;
import gssim.db.dao.data.Task;
import gssim.db.dao.data.TextProperty;
import gssim.db.dao.data.Unit;
import gssim.db.dao.data.UnitAllTimeline;
import gssim.db.dao.data.UnitDetails;
import gssim.db.dao.data.UnitEnTimeline;
import gssim.db.dao.data.User;
import gssim.db.find.Finder;
import gssim.db.mysql.AllocationDAO;
import gssim.db.mysql.AllocationDetailsDAO;
import gssim.db.mysql.BlobPropertyDAO;
import gssim.db.mysql.ConfigurationDAO;
import gssim.db.mysql.ExperimentDAO;
import gssim.db.mysql.MetaexperimentDAO;
import gssim.db.mysql.ExperimentStatsDAO;
import gssim.db.mysql.MySQLDAOFactory;
import gssim.db.mysql.QueuesDAO;
import gssim.db.mysql.PluginDAO;
import gssim.db.mysql.PluginCompatibilityDAO;
import gssim.db.mysql.ReservationDAO;
import gssim.db.mysql.ReservationDetailsDAO;
import gssim.db.mysql.ResourceAllTimelineDAO;
import gssim.db.mysql.ResourceDAO;
import gssim.db.mysql.ResourceEnTimelineDAO;
import gssim.db.mysql.TaskDAO;
import gssim.db.mysql.TextPropertyDAO;
import gssim.db.mysql.UnitAllTimelineDAO;
import gssim.db.mysql.UnitDAO;
import gssim.db.mysql.UnitDetailsDAO;
import gssim.db.mysql.UnitEnTimelineDAO;
import gssim.db.mysql.UserDAO;

import java.net.MalformedURLException;

import javax.servlet.ServletContext;

/**
 * @author Mateusz Cichenski, Jarek Szymczak
 */
@BlazeDsDestination(portletEntry = false, locales = {"en_US","pl_PL"}, names = {"GSSim Studio","GSSim Studio"}, descriptions = {"Application for GSSim job description","Aplikacja do generowania zada� dla symulatora GSSim"})
public class ResourceChart extends DatabaseHelper {
	
	private Boolean developement = true;

	private static MySQLDAOFactory factory;

	/**
	 * Logger instance for this class
	 */
    private ServiceLog log = ServiceLog.getInstance(ResourceChart.class);

    @BlazeDsMethod()
	public ResourceChartModel setSelectedResourceIndex(Integer index) {

		ResourceChartModel model = (ResourceChartModel) VineFlexUtilClass.getUIModel();
		model.setSelectedResourceIndex(index);
		return model;
	}
    
    @BlazeDsMethod()
	public ResourceChartModel getExperimentConfiguration(Integer expId) {

		ResourceChartModel model = (ResourceChartModel) VineFlexUtilClass.getUIModel();
		
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			
			ExperimentDAO experimentDAO = factory.createExperiment();
			Experiment exp = new Experiment();
			exp.setPK(expId);
			exp = experimentDAO.select(exp);
			
			TextPropertyDAO propertyDAO = factory.createTextProperty();
			Finder finder = Finder.getTextPropertyFinder(exp.getConfigId());

			List<TextProperty> list = propertyDAO.find(finder);
			HashMap<String, String> map = new HashMap<String, String>();
			for (int i = 0; i < list.size(); i++)
			{
				map.put(list.get(i).getName(), list.get(i).getValue());
			}
			map.put("name", exp.getName());
			map.put("pk", exp.getPK().toString());
			map.put("groupId", exp.getMetaexpId().toString());

			model.setExperimentConfiguration(map);

		} catch (SQLException e) {
			setSqlError("Resources", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}
    
	@BlazeDsMethod()
	public ResourceChartModel getResourcesFromDb(Integer expId, String name,
			String type) {

		ResourceChartModel model = (ResourceChartModel) VineFlexUtilClass.getUIModel();
		
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			ResourceDAO resourceDAO = factory.createResource();
			Finder finder = Finder.getResourceFinder(expId, name, type);

			List<Resource> list = resourceDAO.find(finder);
			Resource blank = new Resource();
			blank.setPK(-1);
			blank.setName("(...)");
			list.add(0, blank);

			model.setResourceList(list);

		} catch (SQLException e) {
			setSqlError("Resources", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}
	
	@BlazeDsMethod()
	public ResourceChartModel getResourceAllTimelineFromDb(Integer resourceId, Integer expId,
			Long minTimestampMilis, Long maxTimestampMilis) {

		ResourceChartModel model = (ResourceChartModel) VineFlexUtilClass.getUIModel();
		
		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			ResourceAllTimelineDAO resourceDAO = factory
					.createResourceAllTimeline();

			Timestamp minTimestamp = minTimestampMilis == null ? null
					: new Timestamp(minTimestampMilis);
			Timestamp maxTimestamp = maxTimestampMilis == null ? null
					: new Timestamp(maxTimestampMilis);

			if (resourceId != -1)
			{
				Finder finder = Finder.getResourceAllocationTimelineFinder(resourceId, minTimestamp, maxTimestamp);
				List<ResourceAllTimeline> list = resourceDAO.find(finder);

				model.setResourceTimelineList(list);

			}
			else
			{
				Finder finder = Finder.getResourceAllocationTimelineFinder(
						expId, minTimestamp, maxTimestamp);
				List<ResourceAllTimeline> list = resourceDAO.sum(finder);

				model.setResourceTimelineList(list);

			}

		} catch (SQLException e) {
			setSqlError("Resources allocation timeline", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}

	@BlazeDsMethod()
	public ResourceChartModel getResourceEnTimelineFromDb(Integer resourceId, Integer expId,
			Long minTimestampMilis, Long maxTimestampMilis) {

		ResourceChartModel model = (ResourceChartModel) VineFlexUtilClass.getUIModel();

		Connection connection = null;
		try {
			connection = factory().createDBConnection(dbAddress, dbUser,
					dbPassword);
			ResourceEnTimelineDAO resourceDAO = factory
					.createResourceEnTimeline();

			Timestamp minTimestamp = minTimestampMilis == null ? null
					: new Timestamp(minTimestampMilis);
			Timestamp maxTimestamp = maxTimestampMilis == null ? null
					: new Timestamp(maxTimestampMilis);

			if (resourceId != -1)
			{
				Finder finder = Finder.getResourceAllocationTimelineFinder(resourceId, minTimestamp, maxTimestamp);
				List<ResourceEnTimeline> list = resourceDAO.find(finder);

				model.setResourceTimelineList(list);

			}
			else
			{
				Finder finder = Finder.getResourceAllocationTimelineFinder(
						expId, minTimestamp, maxTimestamp);
				List<ResourceEnTimeline> list = resourceDAO.sum(finder);

				model.setResourceTimelineList(list);

			}

		} catch (SQLException e) {
			setSqlError("Resources energy timeline", model, e);
		} catch (InstantiationException e) {
			setDbConnectionError(model, e);		
		} catch (IllegalAccessException e) {
			setDbConnectionError(model, e);	
		} catch (ClassNotFoundException e) {
			setDbConnectionError(model, e);	
		} catch (Exception e) {
			setError("Unexpected error occured", model, e);	
		} finally {
			closeConnection(connection, model);
		}

		return model;
	}
	
	private void closeConnection(Connection connection, ResourceChartModel model) {
		String error = model.getError();
		
		if (connection != null)
			try {
				connection.close();
			} catch (SQLException e) {
				error = model.getError();
				if (error == null || error.equals("")) {
					error = "Error while trying to close the SQL connection";
				} else {
					error += System.getProperty("line.separator");
					error += "Error while trying to close the SQL connection";
				}
			}

		model.setError(error);
	}

	private void setSqlError(String name, ResourceChartModel model, Exception e) {
		setError(name + ": an SQL exception occured while trying retrieve data from database", model, e);
	}
	
	private void setDbConnectionError(ResourceChartModel model, Exception e) {
		setError("An exception occured while trying to create MySQLDAOFactory", model, e);
	}
	
	private void setError(String messageForUser, ResourceChartModel model, Exception e) {
		
		String error = messageForUser;
		
		if(developement)
		{
			error += System.getProperty("line.separator");
			error += "Error details:";
			error += System.getProperty("line.separator");
			ByteArrayOutputStream baos = new ByteArrayOutputStream();
			PrintStream ps = new PrintStream(baos);
			e.printStackTrace(ps);
			String stackTrace = baos.toString();		
			error += stackTrace;
		}
		
		model.setError(error);
	}			
	
	private MySQLDAOFactory factory() throws InstantiationException, IllegalAccessException, ClassNotFoundException {
		if(factory == null)
			factory = new MySQLDAOFactory();
		return factory;
	}
	/* END OF DB Methods */
}